include \masm32\include\masm32rt.inc
include    Strings.inc
includelib RandName.lib
includelib Strings.lib
GenPassword	   			proto :DWORD,:DWORD
OpenAndMapFile 			proto :DWORD,:DWORD,:DWORD,:DWORD
CreateConditional 		proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
FindMisMatches			proto
WriteEndIF				proto
CloseMapFile   			proto :DWORD,:DWORD,:DWORD
RemoveSpaces   			proto :DWORD
GetToken 	   			proto :DWORD, :DWORD, :BYTE, :DWORD, :BYTE
SetTextColor			proto :DWORD,:DWORD
GetConsoleColors		proto :DWORD,:DWORD
DoBanner				proto	
ParseInto4Parts			proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
HandleCmdLine			proto
InStrI					proto :DWORD,:DWORD
HandleError				proto
GetSourceName			proto :DWORD
     CTEXT MACRO text:VARARG	
            local TxtName
              .data
               TxtName BYTE text,0
              .code
            EXITM <ADDR TxtName>
     ENDM

.data?
hFileRead 				dd ?
hFileWrite 				dd ?
hMapFile  				dd ?
pMemory   				dd ?
spos      				dd ?
linesize  				dd ?
FoundConditional 		dd ?
CMDBUFF                 db 2048 dup (?)
lineBuf 				db 2048 dup (?)
lineBufB 				db 2048 dup (?)
conditionbuf 			db 2048 dup (?)
ErrorBuf 				db 1024 dup (?)
TEMPBUF 				db 2048 dup (?)
TEMPBUF2 				db 2048 dup (?)
TEMPBUF3 				db 2048 dup (?)
CmdLineBuf 				db 2048 dup (?)
CompareFirstValBuff 	db 512 dup (?)
CompareSymbol 			db 512 dup (?)
CompareSecondValBuff 	db 512 dup (?)
SourceFile				db 512 dup (?)
DestinFile              db 512 dup (?)
if_count 				dd ?
if_endcount 			dd ?
Byteswritten 			dd ?
if_len    				dd ?
CmpFirstValLen 			dd ?
CmpSymbolLen   			dd ?
LocalArray     			dd ?
EndArray       			dd ?
LocalArrayCount 		dd ?
EndArrayCount   		dd ?
forground 				dd ?
background 				dd ?
.data
;where customizable settings are
include config.asm

FILEOPEN            db " - Opening '%s'...",13,10,0
INVALIDCOUNTERROR 	db " - ERROR MISMATCH (%s), there are %d %s(s) and %d %s(s)!",13,10,0
VALIDCOUNT          db " - No Mismatch Found, (%d)%s's - (%d)%s's, proceeding...",13,10,0
Finished            db " - Generated '%s' Successfully!",13,10,0
EMPTYCMDLINE        db " - ERROR Empty cmdline.",13,10,0
EMPTYPROCESSNAME    db " - ERROR Empty process name.",13,10,0	   
NOSOURCEFILE        db " - ERROR No source file specified.",13,10,0
MISMATCHLOOK        db " - Looking for '%s/%s mismatches'...",13,10,0
ERRORMSGF           db " - ERROR %s",13,10,0
Banner byte  "-------------------------------------------------------",13,10
 	   byte  "                                                 .;    ",13,10	  
 	   byte  "                                               .`;'    ",13,10	 
 	   byte  "                                           . ` ;;'     ",13,10	
 	   byte  "                                  . ` `  `   ;;;'      ",13,10	
 	   byte  "                                `       @  ;;;         ",13,10	
 	   byte  "                             `            ;;;          ",13,10	
 	   byte  "                           `            ;;;;           ",13,10	
 	   byte  "                         `            ;;;;;.           ",13,10	
 	   byte  "                       `           .;;;;;;**.          ",13,10	
 	   byte  "                      `          ;`* .;;; `**.         ",13,10	
 	   byte  "                 .  `           ;;`****.    '*.        ",13,10	
 	   byte  "               '** `           ;;;;'****.    .         ",13,10	
 	   byte  "             '****`            ;;;;;`***.              ",13,10	
 	   byte  "           '*****`           ;;;;;;  `**.              ",13,10	
 	   byte  "            ` **`          ;;;;;;;    .*               ",13,10	
 	   byte  "             `*`         ;;;;;;;;                      ",13,10	
 	   byte  "-------------------------------------------------------",13,10	
	   byte  "    PreProcessor for GoASM/MASM v1.0 Beta By E^cube    ",13,10
	   byte  "-------------------------------------------------------",13,10,13,10,0
	   	   	   
	   
MASMCMPFORM          db 13,10,'CMP %s,%s',13,10
				     db '%s @%s',13,10,0
GOASMCMPFORM         db 13,10,'CMP %s,%s',13,10
				 	 db '%s >> @%s',13,10,0				     
				 	 			
ENDCONDITION     	 db '@%s:',13,10,0	
 
ENDCONDITION2    	 db 13,10,'@%s:',13,10,0

INCLUDEEDIT      	 db '#include "%s"',13,10,0
				 				 
NEWLINE          	 db 13,10,0


.code

start:
;show the banner
invoke DoBanner

;handle the cmdline
invoke HandleCmdLine

;attempt to open and map the source files passed to us
invoke wsprintf,addr TEMPBUF,addr FILEOPEN,addr SourceFile
print addr TEMPBUF
invoke OpenAndMapFile,addr SourceFile,addr hFileRead,addr hMapFile,addr pMemory


invoke wsprintf,addr DestinFile,addr TEMPPREFIX,addr SourceFile
;this is a test run, we loop through the file line by line in memory and see 
;if we have any IF_STATEMENTS, ELSEIF_STATEMENT,etc..
;and if we do also make sure the number of ENDIF_STATEMENT's match the number of IF_STATEMENT statements
;if they don't we display a error and exit
;----------------------------------------------------------------
.if SKIPIFCHECK==0
	mov FoundConditional,0
	invoke wsprintf,addr TEMPBUF,addr MISMATCHLOOK,addr IF_STATEMENT,addr ENDIF_STATEMENT
	print addr TEMPBUF
	invoke FindMisMatches
.endif

;we found a IF_STATEMENT etc... and don't see any errors
;so lets generate the temp file where will be writing the code to
;and loop through the source line by line writing out the data until we find a conditional
;create our local condition label array

mov LocalArrayCount,0
invoke CreateArray,80000
mov LocalArray,eax

;create our endif array
mov EndArrayCount,0
invoke CreateArray,80000
mov EndArray,eax

invoke CreateFile,addr DestinFile,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_WRITE or FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,NULL
mov  hFileWrite,eax
.if eax==INVALID_HANDLE_VALUE
	invoke HandleError
	invoke CloseMapFile,hMapFile,hFileRead,pMemory
	invoke ExitProcess,0
.endif

invoke RtlZeroMemory,addr lineBuf,2048
invoke RtlZeroMemory,addr lineBufB,2048
invoke RtlZeroMemory,addr conditionbuf,2048
mov spos,0
@readline2:
invoke readline,pMemory,addr lineBuf,spos
mov spos,eax
mov linesize,ecx

;zero means empty line
cmp ecx,0
je  @Skipthisline2

;backup the line data before we mess with it
invoke lstrcpy,addr lineBufB,addr lineBuf
;remove leading and trailing spaces from the line
invoke RemoveSpaces,addr lineBuf

;parses the line into 4 parts if part1 = our if condition(.if,.elseif), otherwise fails
invoke ParseInto4Parts,addr lineBuf,addr conditionbuf,addr CompareFirstValBuff,addr CompareSymbol,addr CompareSecondValBuff
cmp eax,0
je @F

;generate label name
invoke RtlZeroMemory,addr TEMPBUF2,2048
invoke GenPassword,addr TEMPBUF2,SYMBOLLEN

;generate endif
invoke RtlZeroMemory,addr TEMPBUF3,2048
invoke GenPassword,addr TEMPBUF3,SYMBOLLEN

;add both to their own arrays for later use
invoke AddString,LocalArray,addr TEMPBUF2
add LocalArrayCount,1
invoke AddString,EndArray,addr TEMPBUF3
add EndArrayCount,1


invoke RtlZeroMemory,addr TEMPBUF,2048
invoke CreateConditional,addr TEMPBUF,addr CompareFirstValBuff,addr CompareSymbol,addr CompareSecondValBuff,addr TEMPBUF2

invoke lstrlen,addr TEMPBUF
invoke WriteFile,hFileWrite,addr TEMPBUF,eax,addr Byteswritten,0

jmp @NexlineX
@@:
;check for .endif
invoke lstrcmpi,addr conditionbuf,addr ENDIF_STATEMENT
cmp eax,0
jne @F
invoke WriteEndIF
jmp  @NexlineX
@@:
@Skipthisline2:
cmp linesize,0
je  @NexlineX
;write the line data to the temp file
invoke WriteFile,hFileWrite,addr lineBufB,linesize,addr Byteswritten,0
invoke WriteFile,hFileWrite,addr NEWLINE,2,addr Byteswritten,0

@NexlineX:
invoke Sleep,1
.if spos!=0
	jmp @readline2
.endif
@finshed2:


;cleanup we're done
invoke CloseMapFile,hMapFile,hFileRead,pMemory
invoke wsprintf,addr TEMPBUF,addr Finished,addr DestinFile
print addr TEMPBUF
invoke ExitProcess,0

;parses the line into 4 parts if part1 = our if condition, otherwise fails
ParseInto4Parts proc iLine:DWORD,Part1:DWORD,Part2:DWORD,Part3:DWORD,Part4:DWORD
;------------------------------------------------------
;part1 .if/.elseif/.else
;------------------------------------------------------
invoke GetToken,Part1,iLine,32,1,0
invoke RemoveSpaces,Part1
invoke lstrlen,Part1
.if eax==0
	ret
.endif

;check for .if
invoke lstrcmpi,Part1,addr IF_STATEMENT
.if eax!=0
	xor eax,eax
	ret
.endif

;------------------------------------------------------
;part2 the first compare value
;------------------------------------------------------
invoke lstrlen,addr IF_STATEMENT
mov if_len,eax
invoke lstrlen,iLine
sub eax,if_len
invoke szRight,iLine,addr TEMPBUF,eax
invoke RemoveSpaces,addr TEMPBUF
invoke GetToken,Part2,addr TEMPBUF,32,1,0
invoke lstrlen,Part2
mov CmpFirstValLen,eax
invoke RemoveSpaces,Part2

;------------------------------------------------------
;part3 the compare symbol(=,<,!=,etc...)
;------------------------------------------------------
;in .if ecx > edx    CompareFirstValBuff will =  ecx
invoke lstrlen,addr TEMPBUF
sub eax,CmpFirstValLen
invoke szRight,addr TEMPBUF,addr TEMPBUF2,eax
invoke RemoveSpaces,addr TEMPBUF2
invoke GetToken,Part3,addr TEMPBUF2,32,1,0
invoke RemoveSpaces,Part3
;----------------------------------------------

;------------------------------------------------------
;part4 the second compare value
;------------------------------------------------------
;CompareFirstValBuff has our first compare value in it and CompareSymbol has <,>,= etc in it
invoke lstrlen,Part3
mov CmpSymbolLen,eax

invoke RtlZeroMemory,addr TEMPBUF,2048
invoke lstrlen,addr TEMPBUF2
sub eax,CmpSymbolLen

invoke szRight,addr TEMPBUF2,addr TEMPBUF,eax
invoke RemoveSpaces,addr TEMPBUF

invoke GetToken,Part4,addr TEMPBUF,32,1,0
invoke RemoveSpaces,Part4
mov eax,1
ret
ParseInto4Parts endp

;shows our banner
DoBanner proc
invoke GetConsoleColors,addr forground,addr background
invoke SetTextColor, 15, 1
print addr Banner
invoke SetTextColor, 15, background
ret
DoBanner endp

;finds if/endif mistmatches
FindMisMatches proc
mov spos,0
@readline:
invoke readline,pMemory,addr lineBuf,spos
mov spos,eax
;zero means empty line
cmp ecx,0
je @Skipthisline

;remove leading and trailing spaces from the line
invoke RemoveSpaces,addr lineBuf
invoke GetToken,addr conditionbuf,addr lineBuf,32,1,0
invoke RemoveSpaces,addr conditionbuf

;check for .if
invoke lstrcmpi,addr conditionbuf,addr IF_STATEMENT
.if eax==0
	mov FoundConditional,1
	add if_count,1
	jmp @Skipthisline
.endif

;check for .endif
invoke lstrcmpi,addr conditionbuf,addr ENDIF_STATEMENT
.if eax==0
	mov FoundConditional,1
	add if_endcount,1
.endif

@Skipthisline:
invoke Sleep,1
.if spos!=0
	jmp @readline
.endif
@finshed:
;----------------------------------------------------------------

;if we don't have any IF_STATEMENTS just unmap file and pass on the compile switches and info to GoASM/MASM
;then exit
Cmp FoundConditional,1
je @F
print "No If conditions found, exiting",13,10
invoke CloseMapFile,hMapFile,hFileRead,pMemory
invoke ExitProcess,0
@@:
mov ecx,if_endcount
cmp if_count,ecx
je @F
invoke wsprintf,addr ErrorBuf,addr INVALIDCOUNTERROR,if_count,addr IF_STATEMENT,if_endcount,addr ENDIF_STATEMENT
print addr ErrorBuf,13,10
invoke CloseMapFile,hMapFile,hFileRead,pMemory
invoke ExitProcess,0
@@:	
invoke wsprintf,addr ErrorBuf,addr VALIDCOUNT,if_count,addr IF_STATEMENT,if_endcount,addr ENDIF_STATEMENT
print addr ErrorBuf
ret
FindMisMatches endp

;writes in the jmp to address(replaces the .endif)
WriteEndIF proc
LOCAL toplocalindex:DWORD
LOCAL topendindex:DWORD
LOCAL finalend:DWORD
invoke RtlZeroMemory,addr TEMPBUF,2048
invoke GetString,LocalArray,LocalArrayCount
invoke lstrcpy,addr TEMPBUF,eax

invoke DeleteString,LocalArray,LocalArrayCount
sub LocalArrayCount,1
invoke RtlZeroMemory,addr TEMPBUF2,2048


mov eax,EndArrayCount
mov topendindex,eax
invoke GetString,EndArray,eax
invoke lstrcpy,addr TEMPBUF2,eax


cmp topendindex,1
jne @notfinalif
mov finalend,1
@notfinalif:
invoke DeleteString,LocalArray,topendindex
sub EndArrayCount,1


invoke RtlZeroMemory,addr TEMPBUF3,2048
invoke wsprintf,addr TEMPBUF3,addr ENDCONDITION,addr TEMPBUF
jmp  @writedata

@writedata:
invoke lstrlen,addr TEMPBUF3
invoke WriteFile,hFileWrite,addr TEMPBUF3,eax,addr Byteswritten,0
ret
WriteEndIF endp

;generates the label like
;cmp ecx,1
;jne @ourandomlabel
CreateConditional proc oBuf,iCompareVal1,iCondition,iCompareVal2,iLocalLabel
LOCAL conditbuf[255]:BYTE
invoke RtlZeroMemory,addr conditbuf,255
;<
invoke lstrcmpi,iCondition,addr LESS_THAN
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JGE")
	jmp @endcond
.endif 	
;>
invoke lstrcmpi,iCondition,addr GREATER_THAN
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JLE")
	jmp @endcond
.endif 
;==
invoke lstrcmpi,iCondition,addr EQUALTO
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JNE")
	jmp @endcond
.endif 
;=
invoke lstrcmpi,iCondition,addr EQUALTO2
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JNE")
	jmp @endcond
.endif
;<=
invoke lstrcmpi,iCondition,addr LESSTHANEQUAL
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JG")
	jmp @endcond
.endif
;=<
invoke lstrcmpi,iCondition,addr LESSTHANEQUAL2
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JG")
	jmp @endcond
.endif
;>=
invoke lstrcmpi,iCondition,addr GREATERTHANEQUAL
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JL")
	jmp @endcond
.endif
;=>
invoke lstrcmpi,iCondition,addr GREATERTHANEQUAL2
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JL")
	jmp @endcond
.endif
;!=
invoke lstrcmpi,iCondition,addr NOTEQUALTO
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JE")
	jmp @endcond
.endif
;=!
invoke lstrcmpi,iCondition,addr NOTEQUALTO2
.if eax==0
	invoke lstrcpy,addr conditbuf,CTEXT("JE")
	jmp @endcond
.endif
@endcond:	
.if ASSUMEMASM==1
	invoke wsprintf,oBuf,addr MASMCMPFORM,iCompareVal1,iCompareVal2,addr conditbuf,iLocalLabel	
.else
	invoke wsprintf,oBuf,addr GOASMCMPFORM,iCompareVal1,iCompareVal2,addr conditbuf,iLocalLabel
.endif
ret
CreateConditional endp

OpenAndMapFile proc iFile,iFileHand,iMapFile,iMapView
	invoke CreateFile,iFile,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL
	.if eax==INVALID_HANDLE_VALUE
		invoke HandleError
		invoke ExitProcess,0
	.endif
	mov   edx,iFileHand
	mov  [edx],eax
	invoke CreateFileMapping,hFileRead,NULL,PAGE_READONLY,0,0,NULL
	.if eax==NULL
		invoke HandleError
		invoke CloseHandle,iFileHand
		invoke ExitProcess,0
	.endif
	mov  edx,iMapFile
	mov  [edx],eax
	invoke MapViewOfFile,hMapFile,FILE_MAP_READ,0,0,0
	.if eax==NULL
		invoke HandleError
		invoke CloseHandle,iFileHand
		invoke CloseHandle,iMapFile
		invoke ExitProcess,0
	.endif
	mov  edx,iMapView
	mov [edx],eax
    ret
OpenAndMapFile endp

CloseMapFile proc iMAP,iFILE,iView
	invoke UnmapViewOfFile,iView
    invoke CloseHandle,iMAP
    mov    iMAP,0
    invoke CloseHandle,iFILE
    ret
CloseMapFile endp


RemoveSpaces proc iBuf
invoke ltrim,iBuf,iBuf
invoke rtrim,iBuf,iBuf
ret
RemoveSpaces endp


GetToken proc uses eax ecx esi edi dwBuffer:dword, dwString:dword, bSeperator:byte, dwNumber:dword, bGetAll:byte
mov ecx, 0
mov esi, dwString
mov edi, dwBuffer
@@:
lodsb
.if al == 0
  stosb
  jmp @F
.elseif al == bSeperator
  inc ecx
 .if ecx == dwNumber
    .if bGetAll == FALSE
      mov al, 0
      stosb
      jmp @F
    .endif  
  .elseif
    .if bGetAll == TRUE 
      .if ecx < dwNumber
        mov edi, dwBuffer  
      .endif  
    .else
      mov edi, dwBuffer  
      jmp @B
    .endif
  .endif  
.endif
stosb
jmp @B
@@:
ret
GetToken endp

SetTextColor proc fore:DWORD,back:DWORD

    LOCAL hStdOut:DWORD

    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov   hStdOut,eax
    mov   eax,back
    shl   eax,4
    or    eax,fore
    invoke SetConsoleTextAttribute,hStdOut,eax
    ret
   
SetTextColor endp

;written by Greg
GetConsoleColors PROC pFGx:DWORD, pBGx:DWORD
    ; If the procedure succeeds, it returns the current colors
    ; in the variables pointed to by pFGx and pBG, and returns 0 in eax.
    ;
    ; If the procedure fails it returns the error from the call to
    ; GetConsoleScreenBufferInfo.

    LOCAL CSBI:CONSOLE_SCREEN_BUFFER_INFO

    IFNDEF hStdOut
        .DATA
            hStdOut DWORD 0
        .CODE
    ENDIF

    .IF hStdOut == 0
        ; Get a handle to the STDOUT screen buffer
        INVOKE GetStdHandle, STD_OUTPUT_HANDLE
        mov hStdOut, eax
    .ENDIF

    INVOKE GetConsoleScreenBufferInfo, hStdOut, ADDR CSBI
    .IF eax != 0
        ; get the low nibble
        mov edx, pFGx
        mov ax, CSBI.wAttributes
        and al, 0Fh
        movzx ecx, al
        mov [edx], ecx
        ; get the high nibble
        mov edx, pBGx
        mov ax, CSBI.wAttributes
        and al, 0F0h
        shr al, 4
        movzx ecx, al
        mov [edx], ecx
        ; set the return
        xor eax, eax
    .ELSE
        ; set the return
        INVOKE GetLastError
    .ENDIF
    ret
GetConsoleColors ENDP

HandleCmdLine proc
LOCAL proclen:DWORD
LOCAL cmdlen:DWORD
invoke GetCommandLine
invoke lstrcpy,addr CMDBUFF,eax
;make sure cmdline isn't empty
invoke lstrlen,addr CMDBUFF
.if eax==0
	print addr NOSOURCEFILE
	invoke ExitProcess,0
.endif
mov cmdlen,eax

;make sure a source file was specified
invoke InStrI,addr CMDBUFF,CTEXT(".asm")
.if sdword ptr eax < 1
	print addr NOSOURCEFILE
	invoke ExitProcess,0
.endif

;loop through the cmdline args to find our source file
invoke GetSourceName,addr SourceFile
.if eax==0
	print addr NOSOURCEFILE
	invoke ExitProcess,0
.endif

invoke GetCL,0,addr TEMPBUF
invoke lstrlen,addr TEMPBUF
.if eax==0
	print addr EMPTYPROCESSNAME
	invoke ExitProcess,0
.endif
;cut off our process name, and replace it with path/name to MASM or GOasm, along with the params
mov proclen,eax
mov ecx,cmdlen
sub ecx,eax
invoke szRight,addr CMDBUFF,addr TEMPBUF2,ecx
invoke RemoveSpaces,addr TEMPBUF2
invoke RtlZeroMemory,addr CmdLineBuf,2048
.if ASSUMEMASM==1
	invoke wsprintf,addr CmdLineBuf,CTEXT("%s %s"),addr MASMPATH,addr TEMPBUF2
.else
	invoke wsprintf,addr CmdLineBuf,CTEXT("%s %s"),addr GOASMPATH,addr TEMPBUF2
.endif
ret
HandleCmdLine endp

GetSourceName proc oBuf:DWORD
LOCAL currentparm:DWORD
mov currentparm,1
@@:
invoke GetCL,currentparm,oBuf
invoke InStrI,oBuf,CTEXT(".asm")
.if sdword ptr eax > 0
	ret
.endif
invoke lstrlen,oBuf
.if eax==0
	ret
.endif
add currentparm,1
.if currentparm > 20
	xor eax,eax
	ret
.endif
jmp @B
ret
GetSourceName endp

InStrI proc iBuf:DWORD,iStr:DWORD
LOCAL tmpiBufF[2048]:BYTE
LOCAL tmpiBufx[256]:BYTE
invoke RtlZeroMemory,addr tmpiBufF,2048
invoke RtlZeroMemory,addr tmpiBufx,256
invoke lstrcpy,addr tmpiBufF,iBuf
invoke szLower,addr tmpiBufF
invoke lstrcpy,addr tmpiBufx,iStr
invoke szLower,addr tmpiBufx
invoke InString,1,addr tmpiBufF,addr tmpiBufx
ret
InStrI endp

HandleError proc
LOCAL lpMsgBuffer     : LPVOID ;dword
; calculate language ID, asm version of MAKELANGID
mov cx, SUBLANG_DEFAULT
shl ecx, 10
;or  cx, LANG_NEUTRAL        ; LANG_NEUTRAL = 0, nothing necessary

; Setup parameters for FormatMessage, normal pushing to use some
; params directly (e.g. GetLastError returns the ID in eax, but I
; can't use this register in "invoke")

push NULL                ; we don't need this
push 0                   ; min. size of output buffer if we use
; FORMAT_MESSAGE_ALLOCATE_BUFFER
lea  ebx,lpMsgBuffer     ; get address of our buffer
push ebx                 ; address of buffer
push ecx                 ; our language ID, calculated above
invoke GetLastError      ; get error number
push eax                 ; push return value = error ID
push NULL                ; can be used to format a string, we don't need it
mov edx, FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM
push edx                 ; some flags, check your doc for more
call FormatMessage       ; here we go

invoke wsprintf,addr TEMPBUF,addr ERRORMSGF,lpMsgBuffer
print addr TEMPBUF
invoke LocalFree, lpMsgBuffer
ret
HandleError endp
end start